摘要:題目解答最重要的是用保存每個掃過結點的最大路徑。我開始做的時候,用全局變量記錄的沒有返回值,這樣很容易出錯,因為任何一個用到的環節都有可能改變值,所以還是在函數中定義,把當前的直接返回計算不容易出錯。
題目:
Given an integer matrix, find the length of the longest increasing path.
From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move outside of the boundary (i.e. wrap-around is not allowed).
Example 1:
nums = [ [9,9,4], [6,6,8], [2,1,1] ]
Return 4
The longest increasing path is [1, 2, 6, 9].
Example 2:
nums = [ [3,4,5], [3,2,6], [2,2,1] ]
Return 4
The longest increasing path is [3, 4, 5, 6]. Moving diagonally is not allowed.
解答:
最重要的是用cache保存每個掃過結點的最大路徑。我開始做的時候,用全局變量記錄的max, dfs沒有返回值,這樣很容易出錯,因為任何一個用到max的環節都有可能改變max值,所以還是在函數中定義,把當前的max直接返回計算不容易出錯。
public class Solution { public int DFS(int[][] matrix, int i, int j, int[][] cache) { if (cache[i][j] != 0) return cache[i][j]; //改進:記錄下每一個訪問過的點的最大長度,當重新訪問到這個點的時候,就不需要重復計算 int[][] dir = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}}; int max = 1; for (int k = 0; k < dir.length; k++) { int x = i + dir[k][0], y = j + dir[k][1]; if (x < 0 || x > matrix.length - 1 || y < 0 || y > matrix[0].length - 1) { continue; } else { if (matrix[x][y] > matrix[i][j]) { //這里當前結點只算長度1,然后加上dfs后子路徑的長度,比較得出最大值 int len = 1 + DFS(matrix, x, y, cache); max = Math.max(max, len); } } } cache[i][j] = max; return max; } public int longestIncreasingPath(int[][] matrix) { if (matrix == null || matrix.length == 0 || matrix[0].length == 0) return 0; int m = matrix.length, n = matrix[0].length; int[][] cache = new int[m][n]; int max = 1; for (int i = 0; i < m; i++) { for (int j = 0; j < n; j++) { int len = DFS(matrix, i, j, cache); max = Math.max(max, len); } } return max; } }
文章版權歸作者所有,未經允許請勿轉載,若此文章存在違規行為,您可以聯系管理員刪除。
轉載請注明本文地址:http://specialneedsforspecialkids.com/yun/64917.html
摘要:題目要求思路和代碼這里采用廣度優先算法加上緩存的方式來實現。我們可以看到,以一個節點作為開始構成的最長路徑長度是確定的。因此我們可以充分利用之前得到的結論來減少重復遍歷的次數。 題目要求 Given an integer matrix, find the length of the longest increasing path. From each cell, you can ei...
摘要:復雜度思路為了避免搜索已經搜索的點。所以考慮用一個數組,記錄到每一個點能產生的最長序列的長度。考慮用進行搜索,對于每一個點來說,考慮先找到最小的那個點針對每一條路徑的。然后對于每一點再遞增回去,依次累積找到增加的值。 LeetCode[329] Longest Increasing Path in a Matrix Given an integer matrix, find the ...
Problem Given an integer matrix, find the length of the longest increasing path. From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move ou...
Problem Given an integer matrix, find the length of the longest increasing path. From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move ou...
摘要:思路這道題主要使用記憶化遞歸和深度優先遍歷。我們以給定的矩陣的每一個位置為起點,進行深度優先遍歷。我們存儲每個位置深度優先遍歷的結果,當下一次走到這個位置的時候,我們直接返回當前位置記錄的值,這樣可以減少遍歷的次數,加快執行速度。 Description Given an integer matrix, find the length of the longest increasing...
閱讀 617·2023-04-25 18:37
閱讀 2780·2021-10-12 10:12
閱讀 8315·2021-09-22 15:07
閱讀 564·2019-08-30 15:55
閱讀 3174·2019-08-30 15:44
閱讀 2194·2019-08-30 15:44
閱讀 1625·2019-08-30 13:03
閱讀 1560·2019-08-30 12:55